format zx81 as 'rom'

define	NEWLINE 	$76

define	IOANY		$FF	// "any" io address
define	IOADRKBD	$FE	// io address, keyboard check
define	IOADRNMION	$FE	// io address, NMI on
define	IOADRNMIOFF	$FD	// io address, NMI off
define	IOADRBASE	$F4	// io base address
define	LATINT		0	// offset for io address LATINT (special functions)
define	LATROM		1	// offset for io address LATROM (rom latch)
define	LATRAM		2	// offset for io address LATRAM (ram latch)
define	LATUSB		3	// offset for io address LATUSB (usb communication)
define	IOADRLATINT	$F4	// io address, internal mysterious latch
define	IOADRLATROM	$F5	// io address, ROM latch and control signals
define	IOADRLATRAM	$F6	// io address, RAM latch and memory configuration

	ORG	$0

	OUT	(IOADRNMIOFF),A
	DI
	IM	1
	LD	HL,0
	LD	SP,HL
	LD	IX,main
	JR	start
	db	38h-$ dup(NEWLINE)
rst38:
	POP	DE
	OUT	(IOANY),A
	JR	main
start:
	LD	HL,$3FFF
	LD	BC,$0010
	JP	(IX)
pre:
	LD	A,$FF
	LD	R,A
	EI
main:
	XOR	A
	INC	HL
	LD	(HL),A
	SCF
	RL	(HL)
	RL	(HL)
	RL	(HL)
	RL	(HL)
	RL	(HL)
	RL	(HL)
	RL	(HL)
	RL	(HL)
	RL	(HL)
	JR	NC,bad
	OR	(HL)
	JR	NZ,bad
	IN	A,(IOADRKBD)
	RRCA
	JR	NC,vidon
	DJNZ	main
	DEC	C
	JR	Z,start
	JP	(IX)
vidon:
	LD	IX,pre
	JP	(IX)
bad:
	LD	A,L
	OUT	($FF),A
	LD	A,H
	OUT	($FF),A
	LD	B,32
	DJNZ	$
	JR	bad

	db	2000h-$ dup(NEWLINE)

